
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>同源策略和跨域问题 / 憋错料</title>

    <meta name="description" content="同源策略和跨域问题 1 同源策略 所谓同源策略,指的是浏览器对不同源的脚本或者文本的访问方式进行的限制.比如源a的js不能读取或设置引入的源b的元素属性. 那么先定义下什么是同源,所谓同源,就是指两个页面具有相同的协议,主机(也常说域名),端口,三个要素缺一不可. 可以看下面的几个示例来更加清楚的了解一下同源的概念: URL1 URL2 说明 是否允许通信 http://www.foo.com/js/a.js http://www.foo.com/js/b.js 协议.域名.端口都相同 允许 http://www.">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">同源策略和跨域问题</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>1 同源策略</p>
<p>所谓同源策略，指的是浏览器对不同源的脚本或者文本的访问方式进行的限制。比如源a的js不能读取或设置引入的源b的元素属性。</p>
<p><strong>那么先定义下什么是同源，所谓同源，就是指两个页面具有相同的协议，主机（也常说域名），端口，三个要素缺一不可。</strong></p>
<p>可以看下面的几个示例来更加清楚的了解一下同源的概念：</p>
<table>
<thead>
<tr>
<th>URL1</th>
<th>URL2</th>
<th>说明</th>
<th>是否允许通信</th>
</tr>
</thead>
<tbody>
<tr>
<td><a href="http://www.foo.com/js/a.js" rel="external nofollow noreferrer">http://www.foo.com/js/a.js</a></td>
<td><a href="http://www.foo.com/js/b.js" rel="external nofollow noreferrer">http://www.foo.com/js/b.js</a></td>
<td>协议、域名、端口都相同</td>
<td>允许</td>
</tr>
<tr>
<td><a href="http://www.foo.com/js/a.js" rel="external nofollow noreferrer">http://www.foo.com/js/a.js</a></td>
<td><a href="http://www.foo.com:8888/js/b.js" rel="external nofollow noreferrer">http://www.foo.com:8888/js/b.js</a></td>
<td>协议、域名相同，端口不同</td>
<td>不允许</td>
</tr>
<tr>
<td><a href="https://www.foo.com/js/a.js" rel="external nofollow noreferrer">https://www.foo.com/js/a.js</a></td>
<td><a href="http://www.foo.com/js/b.js" rel="external nofollow noreferrer">http://www.foo.com/js/b.js</a></td>
<td>主机、域名相同，协议不同</td>
<td>不允许</td>
</tr>
<tr>
<td><a href="http://www.foo.com/js/a.js" rel="external nofollow noreferrer">http://www.foo.com/js/a.js</a></td>
<td><a href="http://www.bar.com/js/b.js" rel="external nofollow noreferrer">http://www.bar.com/js/b.js</a></td>
<td>协议、端口相同，域名不同</td>
<td>不允许</td>
</tr>
<tr>
<td><a href="http://www.foo.com/js/a.js" rel="external nofollow noreferrer">http://www.foo.com/js/a.js</a></td>
<td><a href="http://foo.com/js/b.js" rel="external nofollow noreferrer">http://foo.com/js/b.js</a></td>
<td>协议、端口相同，主域名相同，子域名不同</td>
<td>不允许</td>
</tr>
</tbody>
</table>
<p>同源策略限制了不同源之间的交互，但是有人也许会有疑问，我们以前在写代码的时候也常常会引用其他域名的js文件，样式文件，图片文件什么的，没看到限制啊，这个定义是不是错了。<strong>其实不然，同源策略限制的不同源之间的交互主要针对的是js中的XMLHttpRequest等请求，下面这些情况是完全不受同源策略限制的。</strong></p>
<ul>
<li><strong>页面中的链接，重定向以及表单提交是不会受到同源策略限制的。</strong>链接就不用说了，导航网站上的链接都是链接到其他站点的。而你在域名<code>www.foo.com</code>下面提交一个表单到<code>www.bar.com</code>是完全可以的。</li>
<li><strong>跨域资源嵌入是允许的，当然，浏览器限制了Javascript不能读写加载的内容</strong>。如前面提到的嵌入的<code>&lt;script src="..."&gt;&lt;/script&gt;，&lt;img&gt;，&lt;link&gt;，&lt;iframe&gt;等</code>。当然，如果要阻止iframe嵌入我们网站的资源(页面或者js等)，我们可以在web服务器加上一个<code>X-Frame-Options DENY</code>头部来限制。nginx就可以这样设置<code>add_header X-Frame-Options DENY;</code>。</li>
</ul>
<p>既然有这么多的情况是没有同源策略限制的，那么通常的跨域问题从何而来呢？转到下一节跨域问题。</p>
<h1>2 跨域问题</h1>
<p>这一节来讨论下跨域问题，当然<strong>前置条件是我们在WEB服务器或者服务端脚本中设置<code>ACCESS-CONTROL-ALLOW-ORIGIN</code>头部，如果设置了这些头部并允许某些域名跨域访问，则浏览器就会跳过同源策略的限制返回对应的内容。此外，如果你不是通过浏览器去获取资源，比如你通过一个python脚本去调用接口或者获取js文件，也不在这个限制之内。</strong></p>
<h2>2.1 Ajax跨域</h2>
<p>通过ajax调用其他域的接口会有跨域问题。比如下面的例子，我在<code>http://www.foo.com/index.html</code>中通过ajax调用请求<code>http://www.bar.com/js/test.js</code>页面，此时是会报错的。</p>
<pre><code>XMLHttpRequest cannot load http://www.bar.com/js/test.js.
No ‘Access-Control-Allow-Origin‘ header is present on the requested resource.
Origin ‘http://www.foo.com‘ is therefore not allowed access.</code></pre>
<p>这是因为我们的WEB服务器没有设置<code>ACCESS-CONTROL-ALLOW-ORIGIN</code>头部，默认情况下是禁止跨域引用资源的。<strong>当然这里有一点要注意，其实这个跨域请求是发送成功了的，服务器也有返回test.js内容，只是浏览器禁止Javascript去取response的数据而已</strong>。如果要设置ACCESS-CONTROL-ALLOW-ORIGIN头部，nginx可以使用下面的代码</p>
<pre><code>add_header ‘Access-Control-Allow-Origin‘ ‘http://www.foo.com‘;
add_header ‘Access-Control-Allow-Credentials‘ ‘true‘;
add_header ‘Access-Control-Allow-Methods‘ ‘GET,POST‘;</code></pre>
<p>另外，我们看到直接通过Javascript去取iframe中的元素也是会报错的，因为域名不同。报错如下所示</p>
<pre><code>Uncaught SecurityError: Failed to read the ‘contentDocument‘ property from ‘HTMLIFrameElement‘: Blocked a frame with origin "http://www.foo.com" from accessing a frame with origin "http://foo.com".
The frame being accessed set "document.domain" to "foo.com", but the frame requesting access did not. Both must set "document.domain" to the same value to allow access.</code></pre>
<p>这时因为我们的主域名相同，因此可以在index.html和test.html中设置<code>document.domain=‘foo.com‘</code>来访问iframe中的元素。<strong>注意，是两个域名下面的文件都要设置，即便是同样的主域名。</strong>当然这是特例，如果是两个完全不同的域名，是没有办法的，你不能把<code>www.foo.com</code>的<code>domain</code>设置成<code>www.163.com</code>。</p>
<p>此外，在index.html里面也可以看到通过<code>&lt;script&gt;,&lt;iframe&gt;</code>等标签都是可以跨域内嵌资源的。</p>
<pre><code># index.html
&lt;!DOCTYPE html&gt;
&lt;html&gt;
&lt;head&gt;
&lt;title&gt;test cross domain&lt;/title&gt;
&lt;script src="/js/jquery.js"&gt;&lt;/script&gt;
&lt;script src="http://www.bar.com/js/test.js"&gt;&lt;/script&gt;
&lt;script&gt;
$(function(){
    document.domain = ‘foo.com‘; //1 注释掉则会报错
    var ifr = document.getElementById("testframe");
    ifr.onload = function(){
        var doc = ifr.contentDocument || ifr.contentWindow.document;
        alert(doc.getElementsByTagName("h1")[0].childNodes[0].nodeValue);
    }
});

$.ajax("http://www.bar.com/js/test.js"); //2 报错
&lt;/script&gt;

&lt;/head&gt;
&lt;body&gt;
&lt;h1&gt;Test Cross Domain&lt;/h1&gt;
&lt;iframe id="testframe" src="http://foo.com/test.html"&gt;&lt;/iframe&gt;
&lt;/body&gt;
&lt;/html&gt;</code></pre>
<p>当然还可以通过<code>iframe，location.hash，window.name，HTML5的postMessage</code>等方法来实现跨域资源访问，更多内容参见<code>Rain Man</code>的这篇文章&nbsp;<a href="http://www.cnblogs.com/rainman/archive/2011/02/20/1959325.html" rel="external nofollow noreferrer">JavaScript跨域总结和解决办法</a>。</p>
<h2>2.2 JSONP跨域访问</h2>
<p>JSONP也是开发中常见到的内容，在jquery中就有封装，通过ajax请求多带上一个jsonp的参数即可。JSONP也能够实现跨域访问资源，但是它的实现原理其实跟ajax没有多少关系，它是通过动态插入<code>&lt;script&gt;</code>标签来实现跨域资源访问的，因为根据前面内容我们已经知道，嵌入跨域资源浏览器是允许的。</p>
<p>下面通过一个简单的例子来说明JSONP的原理。<br />两个文件，第一个是<code>http://www.foo.com/jsonp.html</code>，通过动态创建script标签加载了<code>http://www.bar.com/js/outer.js</code>文件，然后outer.js文件返回的内容正好是一个函数调用，如此，实现了数据传递和回调过程。当然，实际的jsonp接口中，会让你传一个函数名过去，然后返回的数据中回调函数名就是你传的函数名，回调函数的参数则是封装的json格式。jQuery中的jsonp实现原理基本就是这样，更详细的jsonp原理可以参见这篇大作<a href="http://www.cnblogs.com/chopper/archive/2012/03/24/2403945.html" rel="external nofollow noreferrer">深入浅出JSONP</a>。</p>
<pre><code># jsonp.html
&lt;script type="text/javascript"&gt;
    function callback(data) {
        alert(data.message);
    }
    function addScriptTag(src){
    var script = document.createElement(‘script‘);
        script.src = src;
        document.body.appendChild(script);
    }

    window.onload = function(){
        addScriptTag("http://www.foo.com/js/outer.js");
    }
&lt;/script&gt;

# outer.js
callback({message:"success"});</code></pre>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-15 22:12:22 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/add/" title="add">add</a>, <a href="https://www.biecuoliao.com/tag/ref/" title="ref">ref</a>, <a href="https://www.biecuoliao.com/tag/ext/" title="ext">ext</a>, <a href="https://www.biecuoliao.com/tag/nbsp/" title="nbsp">nbsp</a>, <a href="https://www.biecuoliao.com/tag/string/" title="string">string</a>, <a href="https://www.biecuoliao.com/tag/man/" title="man">man</a>, <a href="https://www.biecuoliao.com/tag/test/" title="test">test</a>, <a href="https://www.biecuoliao.com/tag/%e6%83%85%e5%86%b5/" title="情况">情况</a>, <a href="https://www.biecuoliao.com/tag/rda/" title="rda">rda</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>同源策略和跨域问题的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/n3ZPqGM.html" rel="bookmark">同源策略和跨域-总结</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				目录: 1.同源策略 2.跨域 3.几种跨域技术 1.同源策略 什么叫同源? URL由协议.域名.端口和路径组成,如果两个URL的协议.域名和端口相同,则表示他们同源.相反,只要协议,域名,端口有任何一个的不同,就被当作是跨域. e.g. 对于http://store.company.com/dir/page.html进行同源检测: URL 结果 原因 http://store.company.com/dir2/other.html 成功 仅路径不同 http://store.company.c			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4NAzDw3.html" rel="bookmark">JS同源策略和跨域访问</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				同源策略(Same origin policy)是一种约定,它是浏览器最核心也最基本的安全功能,如果缺少了同源策略,则浏览器的正常功能可能都会受到影响.可以说Web是构建在同源策略基础之上的,浏览器只是针对同源策略的一种实现. 1. 什么是同源策略 理解跨域首先必须要了解同源策略.同源策略是浏览器上为安全性考虑实施的非常重要的安全策略. 何谓同源: URL由协议.域名.端口和路径组成,如果两个URL的协议.域名和端口相同,则表示他们同源. 同源策略: 浏览器的同源策略,限制了来自不同源的&quot;doc			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MPWxzz4.html" rel="bookmark">第二百七十四节，同源策略和跨域访问</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				同源策略和跨域访问  什么是同源策略 尽管浏览器的安全措施多种多样,但是要想黑掉一个Web应用,只要在浏览器的多种安全措施中找到某种措施的一个漏洞或者绕过一种安全措施的方法即可.浏览器的各种保安措施之间都试图保持相互独立,但是攻击者只要能在出错的地方注入少许JavaScript,所有安全控制几乎全部瓦解--最后还起作用的就是最弱的安全防线:同源策略.同源策略管辖着所有保安措施,然而,由于浏览器及其插件,诸如Acrobat Reader.Flash 和Outlook Express漏洞频出,致使同			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Mzk5QJ0.html" rel="bookmark">同源策略和跨域访问</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1. 什么是同源策略 理解跨域首先必须要了解同源策略.同源策略是浏览器上为安全性考虑实施的非常重要的安全策略.     何谓同源:         URL由协议.域名.端口和路径组成,如果两个URL的协议.域名和端口相同,则表示他们同源.     同源策略:         浏览器的同源策略,限制了来自不同源的&quot;document&quot;或脚本,对当前&quot;document&quot;读取或设置某些属性. (白帽子讲web安全[1])         从一个域上加载的脚本不允许访问另外一			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MoRj1k4.html" rel="bookmark">同源策略与跨域访问</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1. 什么是同源策略 理解跨域首先必须要了解同源策略.同源策略是浏览器上为安全性考虑实施的非常重要的安全策略.    何谓同源:        URL由协议.域名.端口和路径组成,如果两个URL的协议.域名和端口相同,则表示他们同源.    同源策略:        浏览器的同源策略,限制了来自不同源的&quot;document&quot;或脚本,对当前&quot;document&quot;读取或设置某些属性. (白帽子讲web安全[1])        从一个域上加载的脚本不允许访问另外一个域的文档			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0exyKwM.html" rel="bookmark">解说同源策略和跨域访问</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				尽管浏览器的安全措施多种多样,但是要想黑掉一个Web应用,只要在浏览器的多种安全措施中找到某种措施的一个漏洞或者绕过一种安全措施的方法即可.浏览器的各种保安措施之间都试图保持相互独立,但是攻击者只要能在出错的地方注入少许JavaScript,所有安全控制几乎全部瓦解--最后还起作用的就是最弱的安全防线:同源策略.同源策略管辖着所有保安措施,然而,由于浏览器及其插件,诸如Acrobat Reader.Flash 和Outlook Express漏洞频出,致使同源策略也频频告破. 既然web应用的最			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/02aNzEM.html" rel="bookmark">浏览器的同源策略和跨域访问</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1. 什么是同源策略 理解跨域首先必须要了解同源策略.同源策略是浏览器上为安全性考虑实施的非常重要的安全策略.    何谓同源:        URL由协议.域名.端口和路径组成,如果两个URL的协议.域名和端口相同,则表示他们同源.    同源策略:        浏览器的同源策略,限制了来自不同源的&quot;document&quot;或脚本,对当前&quot;document&quot;读取或设置某些属性.        从一个域上加载的脚本不允许访问另外一个域的文档属性. 举个例子:      			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Mo6Pmx4.html" rel="bookmark">同源策略和跨域解决方案</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				同源策略 一个源的定义 如果两个页面的协议,端口(如果有指定)和域名都相同,则两个页面具有相同的源. 举个例子: 下表给出了相对http://a.xyz.com/dir/page.html同源检测的示例: URL 结果 原因 http://a.xyz.com/dir2/other.html 成功   http://a.xyz.com/dir/inner/another.html 成功   https://a.xyz.com/secure.html 失败 不同协议 ( https和http ) h			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4Q6lrQM.html" rel="bookmark">同源策略与跨域问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在前后端通信时,有时会遇到跨域问题,接下来将从以下几个方面进行跨域详解. 1. 为什么会有跨域问题? 2. 什么是同源策略? 3.前后端通信方式有哪些? 4.解决跨域通信的方式有哪些? 5.解决跨域方式详细说明 为什么会有跨域问题? 答:是由于浏览器的同源策略. 什么是同源策略? 答:同源策略(Same origin policy)是一种约定,它是浏览器最核心也最基本的安全功能. 同源策略限制了从一个源加载的文件或脚本如何与另一个源的资源进行交互.这是一个用于隔离潜在恶意文件的安全机制. 那什么			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MgOjOLM.html" rel="bookmark">11&period; cookie&lowbar;session&lowbar;原生ajax&lowbar;readyState的值&lowbar;同源策略&lowbar;跨域&lowbar;jsonp的使用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1. cookie 浏览器存储技术.(服务器将少量数据交于浏览器存储管理) 作用: 存储数据, 解决 http 协议无状态问题 工作流程: 浏览器发送请求给服务器,请求登录 服务器返回响应给浏览器,此时携带了cookie(其中包含着当前用户的唯一标识) 浏览器接受到响应中cookie,得保存下来 浏览器下一次发送请求时,会自动携带上cookie, 服务器接受到请求,解析cookie,从而判断是哪个用户发送的请求(解决http协议无状态问题) 服务器端的使用: 设置cookie        re			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/V02w123.html" rel="bookmark" class="title">使用Eclipse运行Hadoop 2&period;x MapReduce程序常见问题</a>
					<div>
						1. 当我们编写好MapReduce程序,点击Run on Hadoop的时候,Eclipse控制台输出如下内容: 这个信息告诉我们没有找到log4j.properties文件.如果没有这个文件,程序 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/L3r1vX0.html" rel="bookmark" class="title">20150410--Lnmp&plus;Nginx-01</a>
					<div>
						目录 一.什么是主从复制 1 二.实现原理 1 三.用户授权, 2 1.添加一个用户,给用户授权 2 2.如果删除一个用户 3 四.log-bin日志 3 1.如何开启log-bin日志 3 2.如何 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgLPP80.html" rel="bookmark" class="title">javascript快速排序</a>
					<div>
						假如让你写一个排序,你会怎么写呢?for循环搞定吗?来看下边这个是怎么实现的: function quickSort(arr){ if(arr.length&lt;=1){ return arr; } ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmGKLK3.html" rel="bookmark" class="title">【BZOJ 2820】 YY的GCD</a>
					<div>
						2820: YY的GCD Time Limit: 10 Sec  Memory Limit: 512 MB Submit: 807  Solved: 404 [Submit][Status] Desc ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M61KXZ4.html" rel="bookmark" class="title">org&period;apache&period;commons&period;dbcp&period;SQLNestedException&colon; Cannot load JDBC driver class</a>
					<div>
						org.springframework.transaction.CannotCreateTransactionException: Could not open JDBC Connection for ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyKzVm3.html" rel="bookmark" class="title">&lpar;版本定制&rpar;第5课：基于案例分析Spark Streaming流计算框架的运行源码</a>
					<div>
						本期内容: 1.在线动态计算分类最热门商品案例回顾与演示 2.基于案例分析Spark Streaming的运行源码 第一部分案例: package com.dt.spark.sparkstreamin ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0e5bRE0.html" rel="bookmark" class="title">Html Css Javascripe jQuery 速成经验  support by Mr song   &amp;lt&semi;根据自己所掌握的会修改更新&amp;gt&semi;           第五周作业</a>
					<div>
						我是学软件工程的一名本科学子,最近开始接触网页设计制作.由于时间限制我不得不在较短的时间内,掌握这一体系的主体核心部分. 其中老师(20年的编程经验)给予的速成教学让我受益匪浅.这里我再献丑再总结部分 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPWWpP4.html" rel="bookmark" class="title">Usigi Drop</a>
					<div>
						Boys are notoriously childish but, I can empathize. — Daikichi Daikichi, are you gonna die before me ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bqEgpM.html" rel="bookmark" class="title">从尾到头打印链表 5</a>
					<div>
						利用栈,倒序都可以用栈解决 ? ? 先将数据一个一个压入栈 ? ? 然后再一个一个弹出 ? ? 另外还有一种方法是利用递归,递归其实跟栈类似 ? ? 方法一: ? ? package printLis ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KOVL90.html" rel="bookmark" class="title">&lbrack;linux内核&rsqb;linux内核编程规范</a>
					<div>
						1,__attrubte__关键字的作用 点击打开链接 __attrubte__ ((packed)) 的作用就是告诉编译器取消结构在编译过程中的优化对齐,按照实际占用字节数进行对齐.struct s ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35wEznM.html" rel="bookmark" class="title">SQL Server 2008 R2 企业版&sol;开发版&sol;标准版（中英文下载，带序列号）</a>
					<div>
						一. 简体中文 1. SQL Server 2008 R2 Developer (x86, x64, ia64) – DVD (Chinese-Simplified) File Name: cn_sq ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVqkk14.html" rel="bookmark" class="title">一起talk C栗子吧（第十回：C语言实例--最小公倍数）</a>
					<div>
						各位看官们,大家好.从今天開始,我们讲大型章回体科技小说 :C栗子.也就是C语言实例. 闲话休提, 言归正转.让我们一起talk C栗子吧! 看官们,上一回中咱们说的是最大公约数的样例,这一回咱们说的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDNDN93.html" rel="bookmark" class="title">sql 同一个字段多个信息拼接</a>
					<div>
						今天无意间用到的就记录下来 比如T_Stu_Hobby 学生兴趣表.关联学生表和兴趣表.多对多的关系Stu_ID   Hobby_ID＝＝＝＝＝＝＝＝＝＝＝1           1  1       ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lNwAL4.html" rel="bookmark" class="title">用CSS制作三栏液态布局</a>
					<div>
						下面是CSS代码: body {     margin: 0px;     padding: 0px;}div#header {     clear: both;     height: 50px;  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QoB7Q0.html" rel="bookmark" class="title">配置oozie4&period;10&plus;hadoop2&period;5&period;2</a>
					<div>
						终于将这个神秘的寻象人 oozie 安装配置成功了,这个困扰我好几天, 当看到如下的画面, 我觉得值! 废话少说,看我如何编译和安装过程: (已经将hadoop2.5.2HA 的环境搭建起来了,hiv ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0e9wRp0.html" rel="bookmark" class="title">Django模板输出Dict所有Value的效率问题</a>
					<div>
						一次跑偏之旅! 对于一个惯用C++的人来说,使用Python这种语言的一大障碍就是许多集合类型的操作效率并不如传统的经典数据结构那样直观可见,以及许多实际上涉及到内存分配.对象复制之类的耗时操作被隐藏 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGePEA3.html" rel="bookmark" class="title">为什么要使用接口的这种设计方式，这样有什么好处？</a>
					<div>
						且看如下业务层实现类示例代码: public class UserServiceImpl implements UserService { private UserDAO userDAO; publi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVR9lyM.html" rel="bookmark" class="title">mysql-NDBcluster安装配置说明</a>
					<div>
						Mysql cluster介绍: MySQL Cluster 是一种技术,该技术允许在无共享的系统中部署&quot;内存中&quot;数据库的 Cluster .通过无共享体系结构,系统能够使用廉价的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0Rjypj0.html" rel="bookmark" class="title">uva 1406 - A Sequence of Numbers&lpar;树状数组&rpar;</a>
					<div>
						题目链接:uva 1406 - A Sequence of Numbers 题目大意:给定n个数,有两种操作: Q x:计算与2x取且不为0的数的个数 C x:每个数加上x 输出所有Q操作的和. 解题 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0j9JleM.html" rel="bookmark" class="title">UVa 1513 Movie collection &lpar;树状数组&rpar;</a>
					<div>
						题意:给定给你一叠DV,编号1到n,1在最上面,n在最下面.然后现在给你m个操作,每次都指定一张CD,问要拿走这个CD需要挪走上面多少张CD,并且这个要拿走的CD放在这个叠CD的顶端. 析:这个题要倒 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.030 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
